*-----------------------------------------------------------*
* PROGRAM: DEMO.PRG   - HELP Function for use with 3PX LIB *
* Copyright (c) 1989, Pedro P. Polakoff III                 *
* ----------------------------------------------------------*
* This code is supplied as a sample and demonstration of the*
* functionality and use of the 3PX library. You may include *
* this module in your code to test the function and use of  *
* the 3PX library. Registered owners of 3PX will receive an *
* enhanced version of this code and utility software to help*
* create, edit, and maintain the help screens.              *
*-----------------------------------------------------------*

* Set up environment
  set talk off
  set scoreboard off
  set status off
  set bell off
  set safety off
  set message to 25 CENTER
  set WRAP ON

* GLOBALS for 3PX Library
  PUBLIC OPTARR[13]
  PUBLIC HELP_CODE,CALL_PRG,LINE_NUM,INPUT_VAR,HELPNAM,HNDX
  PUBLIC Cyan,CyanRev,WhiteRed,YellowN,Magenta,Yellow,Green
  PUBLIC Blue,Red,WhiteLo,WhiteHi
  PUBLIC MOUSEOK,TRUE,FALSE,BEEP,BOX,NOBEEP

* INITIALIZATION OF GLOBALS
  TRUE = .T.
  FALSE = .F.
  BOX = TRUE
  BEEP = TRUE
  NOBEEP = FALSE
  WhiteLo = "W/N,N/W,N/N,W/N"
  WhiteHi = "W+/N,N/W,N/N,W+/N"
  WhiteRev = "N/W,W/N,N/N,W/N"
		
IF ISCOLOR()
  Cyan  = "BG/N,GR+/B,N/N,N/BG"
  CyanRev = "N/BG,BG/N,N/N,BG/N"
  WhiteRed  = "W+/R,N/W,N/N,R/W"
  YellowN  = "GR+/N,X/X,N/N,X/X"
  Magenta   = "RB+/N,N/W,N/N,RB+/N"
  Yellow  = "GR+/N,N/W,N/N,N/GR+"
  Green = "G/N,N/W,N/N,G/N"
  Blue = "B/N,N/W,N/N,B/N"
  Red = "R/N,N/W,N/N,R/N"
ELSE
  Cyan  = WhiteLo
  CyanRev = WhiteRev
  WhiteRed  = WhiteRev
  YellowN  = "W/N,X/X,N/N,X/X"
  Magenta   = WhiteHi
  Yellow  = WhiteHi
  Green = WhiteLo
  Blue = WhiteLo
  Red = WhiteLo
ENDIF

if file("HELP.DBF")
  helpnam = "HELP"
else
  temp = getpath("HELP.DBF")
  if temp # ""
    helpnam = left(temp,at(".",temp))
  endif
endif
HNDX = FALSE

IF ISMOUSE()
  MOUSEON(TRUE)
  C_Msg(23,[Mouse Detected & Activated!],WhiteRed)
  MOUSEOK = TRUE
ELSE
  MOUSEOK = FALSE
ENDIF

SET COLOR TO &CYAN.
CLEAR SCREEN
DO MAIN
CLOSE DATABASES
CLEAR SCREEN
QUIT

*============================================================*

PROCEDURE MAIN
  DO WHILE .T.
    HELP_CODE=[MAIN]
    SET COLOR TO &CYAN
    CLEAR SCREEN
    C_MSG(01,EXPAND("3PX DEMO PROGRAM"),WHITERED)
    C_PROMPT(05,"PopMenu","Demo of a POPMENU() function")
    C_PROMPT(07,"Quit","As it implies, Stops this Demo")
    if mouseok
      popstr(0,80,20,"You may use your mouse to select!",Yellow)
    endif
    c_msg(23,"Press F1 for Help Demo, or select a choice",WhiteRed)
    menu to mchoice
    do case
      case mchoice = 1
        do mdemo
      case mchoice = 2
        if getyn(23,"Are you sure you want to Quit","Y",WhiteRed,BOX)
          exit
        endif
    endcase
  ENDDO
RETURN  

procedure mdemo
private dchoice,d
  d = 1
  do while .t.
    optarr[1]="Add"
    optarr[2]="Edit"  
    optarr[3]="Change"  
    optarr[4]="Delete"  
    optarr[5]="First"  
    optarr[6]="Last"  
    optarr[7]="Next"  
    optarr[8]="Prev"  
    optarr[9]="View"  
    optarr[10]="Quit"  
    afill(optarr,' ',11,4)
    d = popmenu(23,optarr,d,Magenta)  
    dchoice = iif(d#0,optarr[d],[])  
    if d = 10  
      exit  
    endif  
    dispmsg(10,"Your Choice was "+dchoice,NOBEEP,whitered,BOX)          
  enddo  
return

PROCEDURE HELP
PARAMETERS CALL_PRG,LINE_NUM,INPUT_VAR  
PRIVATE M_HELPSCR,CUR_DBF,OLDCOLOR  
  OLDCOLOR = SETCOLOR()  
  SAVE SCREEN TO M_HELPSCR  
  Set Color to &Cyan.  
  CLEAR  
  IF FILE([&HELPNAM..DBF])  
    CUR_DBF = ALIAS()               && Push Current Database  
    SELECT 0  
    IF !FILE([&HELPNAM..NTX])  
       USE &HELPNAM.  
       INDEX ON CODE to &HELPNAM.  
    ENDIF  
    USE &HELPNAM. INDEX &HELPNAM. ALIAS HELPFILE  
    SEEK TRIM(UPPER(HELP_CODE))  
    IF FOUND()  
       C_Msg(0,EXPAND(HELPFILE->DESC),WhiteRed)  
       Set Color to &Magenta.  
       @ 1,0 to 23,79 Double  
       Set Color to &Cyan.  
       C_Msg(24,[PgUp, PgDn, Cursor(Mouse) Movement to View  ]+;  
       [      Press ESC to Exit Help],WhiteRed)  
       Set Color to &Yellow.  
       MEMOEDIT(HelpFile->Notes,2,2,22,78,.F.)  
       Set Color to &Cyan.  
    ELSE  
       C_Msg(10,Expand([NO HELP FOUND]),WhiteRed)  
       DispMsg(23,[],BEEP,WhiteRed,BOX)  
    ENDIF  
    USE  
    IF !Empty(CUR_DBF)  
      SELECT &CUR_DBF.                && Return to Current DBF  
    ENDIF  
  ELSE  
    C_Msg(10,Expand([DISK ERROR!]),WhiteRed)  
    C_Msg(11,[The HELP Files were not Found on the Current Drive]+;  
    [ and Path],WhiteRed)  
    C_Msg(12,[Use your Installation Program to Re-Install the Help]+;  
    [ Files.],WhiteRed)  
    DispMsg(23,[],BEEP,WhiteRed,BOX)  
  ENDIF  
  RESTORE SCREEN FROM M_HELPSCR  
  RELEASE M_HELPSCR  
  SET COLOR TO &OLDCOLOR.  
RETURN  
*EOP: HELP
